angular.module('beamng.apps')
.directive('oldnavigation', [function () {
  return {
    template: `
    <div style="box-sizing: border-box;">
      <!-- map container -->
      <div>
        <svg style="position:absolute"></svg>
        <svg style="position:absolute"></svg>
        <svg style="position:absolute"></svg>
      </div>
      <!--
      <svg width="20" height="40" style="position: absolute; top:0; left: 50%; margin-top: -20px; margin-left: -10px; transform: scale(1, 1);">
        <polygon points="0,20, 10,40, 20,20, 10,0" style="fill:#ddd;stroke:#ffffff;stroke-width:1.5" />
        <text x="10" y="26" font-family="Verdana" font-size="17" text-anchor="middle" style="font-weight:bold">N</text>
      </svg>
      <svg width="20" height="40" style="position: absolute; top:0; left: 50%; margin-top: -20px; margin-left: -10px; transform: scale(1, 1);">
        <polygon points="0,20, 10,40, 20,20, 10,0" style="fill:#ddd;stroke:#ffffff;stroke-width:1.5" />
        <text x="10" y="26" font-family="Verdana" font-size="17" text-anchor="middle" style="font-weight:bold">S</text>
      </svg>
      <svg width="20" height="40" style="position: absolute; top:0; left: 50%; margin-top: -20px; margin-left: -10px; transform: scale(1, 1);">
        <polygon points="0,20, 10,40, 20,20, 10,0" style="fill:#ddd;stroke:#ffffff;stroke-width:1.5" />
        <text x="10" y="26" font-family="Verdana" font-size="17" text-anchor="middle" style="font-weight:bold">W</text>
      </svg>
      <svg width="20" height="40" style="position: absolute; top:0; left: 50%; margin-top: -20px; margin-left: -10px; transform: scale(1, 1);">
        <polygon points="0,20, 10,40, 20,20, 10,0" style="fill:#ddd;stroke:#ffffff;stroke-width:1.5" />
        <text x="10" y="26" font-family="Verdana" font-size="17" text-anchor="middle" style="font-weight:bold">E</text>
      </svg>
      -->
    </div>
    `,
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {

      var root = element[0];
      var mapcontainer  = root.children[0];
      var svg  = mapcontainer.children[0];
      var vehsvg  = mapcontainer.children[1];
      var auxsvg  = mapcontainer.children[2];
      var pointer = mapcontainer.children[3];

      let staticMarkersDict = {}
      //var dblclickTimer = -1

      var isFreeCam = false
      var lastIsFreeCam = false
      var camPosition
      var camRotation
      var camPointer

      //var northPointer = root.children[1];
      //var southPointer = root.children[2];
      //var westPointer = root.children[3];
      //var eastPointer = root.children[4];

      var mapReady = false;
      var size = 200;
      var zoomFactor = 3

      root.addEventListener('wheel', function(e) {
        // https://deepmikoto.com/coding/1--javascript-detect-mouse-wheel-direction
        var delta = null,
        direction = false

        if ( !e ) { // if the event is not provided, we get it from the window object
            e = window.event;
        }
        if ( e.wheelDelta ) { // will work in most cases
            delta = e.wheelDelta / 60;
        }
        if ( delta !== null ) {
            direction = delta > 0 ? 'up' : 'down';
        }
        if (direction == "down") {
          (zoomFactor++ < 4)?zoomFactor=zoomFactor++:zoomFactor=4
        } else if (direction == "up") {
          (zoomFactor-- > 1)?zoomFactor=zoomFactor--:zoomFactor=1
        }
      })

      root.addEventListener('click', function(e) {
        //if (dblclickTimer != -1) {
          bngApi.engineLua(`if freeroam_bigMapMode then freeroam_bigMapMode.enterBigMap() end`)
        //} else {
        //  dblclickTimer = 0
        //}
      })

      root.addEventListener('mouseover', function(e) {
        element.css({
          'border': '3px solid #FE6601',
        });
      })
      root.addEventListener('mouseout', function(e) {
        element.css({
          'border': '3px solid rgba(20,20,20,0.8)',
        });
      })

      scope.$on('app:resized', function (event, data) {
        size = Math.min(data.width, data.height);
        angular.element(root).css({
          height: `${size}px`,
          width: `${size}px`
        });

        //angular.element(root).css({'perspective': (size * 2)+'px'});
        //console.log('perspective: ', size)

        //var pSize = size/400; // Nothing specific about 400. It's just ok for scaling the pointer.
        //pSize = Math.max(0.3, pSize);
        //pSize = Math.min(1, pSize);
        //pointer.style.transform=`scale(${pSize}, ${pSize})`;
      });

      var _createCircle = function (x, y, r, c) {
        hu('<circle>', svg).attr({
          cx: x, cy: y, r: 0.5*r, fill: c
        });
      };

      var _createLine = function (p1, p2, color) {
        return hu('<line>', svg).attr({
          x1: p1.x, y1: p1.y, x2: p2.x, y2: p2.y,
          stroke: color,
          strokeWidth: Math.max(p1.radius, p2.radius),
          strokeLinecap: "round",
        });
      };

      //var l = 0;
      var focusPosDebug = null;
      var t = 0;
      var lastSpeed = 1;
      scope.$on('NavigationVehicleUpdateOld', function (event, data) {
        if(!mapReady) return;
        //if(l != 0) return;console.log(data);l=1;
        if (!isFreeCam) {
          var threeDMode = Math.min(1, Math.max(0, data.speed * 0.3)); // 0 = 2d, 1 = full 3d

          var zoom = Math.min(150 + (data.speed * 3.6) * 1.5, 250) * zoomFactor;
          lastSpeed = data.speed;

          // center on what?
          var focusX = -data.px;
          var focusY = data.py;

          // define the view area
          var parts = [
            focusX - zoom,
            focusY - zoom,
            zoom * 2,
            zoom * 2,
          ];
        } else {
          var threeDMode = 0; // 0 = 2d, 1 = full 3d
          if (camPointer === undefined) {
            camPointer = hu('<circle>', auxsvg).attr({cx:0, cy:0, r:10})
            camPointer.css('fill', '#FF6600');
          }
          camPointer.attr("transform", "translate(" + -camPosition[0] + "," + camPosition[1] + ")");

          var zoom = 200 * zoomFactor;
          lastSpeed = data.speed;

          // center on what?
          var focusX = -camPosition[0];
          var focusY = camPosition[1];

          // define the view area
          var parts = [
            focusX - zoom,
            focusY - zoom,
            zoom * 2,
            zoom * 2,
          ];
        }
        if (camPointer && lastIsFreeCam == true && isFreeCam == false) {
          camPointer.attr({cx:0, cy:0, r:0})
        } else if (camPointer && lastIsFreeCam == false && isFreeCam == true) {
          camPointer.attr({cx:0, cy:0, r:10})
        }
        camRotation = (camRotation === undefined)?0:camRotation
        data.rot = camRotation
        lastIsFreeCam = isFreeCam
        auxsvg.setAttribute('viewBox', parts.join(' '));
        vehsvg.setAttribute('viewBox', parts.join(' '));
        svg.setAttribute('viewBox', parts.join(' '));
        // and scale / rotate it
        auxsvg.style.transform = 'scale(3,3) rotate(' + data.rot + 'deg) '
        vehsvg.style.transform = 'scale(3,3) rotate(' + data.rot + 'deg) '
        svg.style.transform = 'scale(3,3) rotate(' + data.rot + 'deg) '

        // draw the center dot
        /*
        if(!focusPosDebug) {
          focusPosDebug = hu('<circle>', svg);
          focusPosDebug.attr({
            cx: focusX, cy: focusY, r: 2, fill: 'red'
          });
        }
        focusPosDebug.attr({cx: focusX, cy: focusY});
        */


        //pointer.style.transform = `translate(0, ` + yOffset + `)`;

        // 3d mode panning
        var rotX = threeDMode * 50;
        element.css({'transform': 'rotateX(' + rotX + 'deg)'});
        // move the view, so the play is at the bottom
        mapcontainer.style.transform = 'rotateX(' + rotX + 'deg) translate(0, ' + Math.min(size * 0.35, Math.floor(threeDMode * zoom * 0.5)) + 'px)';
        mapcontainer.style.perspective = '150px'
        element.css({'box-shadow': '0px '+ rotX / 5 +'px rgb(20,20,20)'})

        //for (var marker in staticMarkersDict.missions) {
          //staticMarkersDict.missions[marker].marker.css('box-shadow', '0px '+ 50 / 5 +'px #FFFFFF')
        //}

        //t+=0.1;

        /*
        var degreeNorth = data.rot;
        var npx =            - Math.cos(degreeNorth * Math.PI / 180) * size * 0.46
        var npy = size * 0.5 - Math.sin(degreeNorth * Math.PI / 180) * size * 0.46 - 3.5; // the magic 4
        northPointer.style.transform = 'translate(' + npx + 'px,' + npy + 'px) rotate(' + (-90 + degreeNorth) + 'deg) ';

        var degreeSouth = degreeNorth + 180;
        npx =            - Math.cos(degreeSouth * Math.PI / 180) * size * 0.46
        npy = size * 0.5 - Math.sin(degreeSouth * Math.PI / 180) * size * 0.46 - 3.5;
        southPointer.style.transform = 'translate(' + npx + 'px,' + npy + 'px) rotate(' + (-90 + degreeSouth) + 'deg) ';

        var degreeWest = degreeNorth - 90;
        npx =            - Math.cos(degreeWest * Math.PI / 180) * size * 0.46
        npy = size * 0.5 - Math.sin(degreeWest * Math.PI / 180) * size * 0.46 - 3.5;
        westPointer.style.transform = 'translate(' + npx + 'px,' + npy + 'px) rotate(' + (-90 + degreeWest) + 'deg) ';

        var degreeEast = degreeNorth + 90;
        npx =            - Math.cos(degreeEast * Math.PI / 180) * size * 0.46
        npy = size * 0.5 - Math.sin(degreeEast * Math.PI / 180) * size * 0.46 - 3.5;
        eastPointer.style.transform = 'translate(' + npx + 'px,' + npy + 'px) rotate(' + (-90 + degreeEast) + 'deg) ';
        */

        /*
        var s = 1 + 5 * threeDMode;
        var br = Math.max(0, 50 - threeDMode * 50)
        element.css({
          'border-radius': br + '%',
        })
        */


      });

      scope.$on('$destroy', function () {
        bngApi.activeObjectLua('extensions.unload("uiNaviOld");');
        bngApi.engineLua('extensions.unload("ui_uiNaviOld")');
      });

      scope.$on('VehicleChange', function (event, data) {
        bngApi.activeObjectLua('extensions.load("uiNaviOld")');
      });

      // receive live data from the GE map
      var vehicleShapes = {};
      var lastPlayerID = -1;
      scope.$on('NavigationMapUpdateOld', function (event, data) {
        if(!mapReady) return;
        //console.log("NavigationMapUpdate", data)
        isFreeCam = data.isFreeCam
        camRotation = data.camRotationZ
        camPosition = data.camPosition

        //dblclickTimer = (dblclickTimer > -1 && dblclickTimer < 1)?dblclickTimer=dblclickTimer+data.dt:dblclickTimer = -1

        function updatePlayerShape(key) {
          //console.log('updatePlayerShape', key)
          if(vehicleShapes[key]) vehicleShapes[key].remove();
          var isPlayer = (key == data.playerID)

          if(isPlayer) {
            // remove the player icon, its hardcoded
            vehicleShapes[key] = hu('<polygon>', vehsvg)
            vehicleShapes[key].attr('points', '0,-10 -8,10, 0,7, 8,10')
            vehicleShapes[key].css('fill', '#FF6600');
            vehicleShapes[key].css('stroke', '#ffffff');
            vehicleShapes[key].css('stroke-width', '1.5px');
          } else {
            vehicleShapes[key] = hu('<polygon>', vehsvg)
            vehicleShapes[key].attr('points', '0,-10 -8,10, 0,7, 8,10')
            vehicleShapes[key].css('fill', '#607d8b');
            vehicleShapes[key].css('stroke', '#ffffff');
            vehicleShapes[key].css('stroke-width', '1.5px');
          }
        }

        // update shape positions
        for (var key in data.objects) {
          var o = data.objects[key];

          if (vehicleShapes[key]) {
            var px = -o.pos[0];
            var py = o.pos[1];
            var rot = Math.floor(-o.rot);
            var iconScale = (!isFreeCam)?((o.id == data.playerID)?Math.min(3, 1 + lastSpeed * 0.5):Math.min(2, 1 + lastSpeed * 0.25)):1.5;
            vehicleShapes[key].attr("transform", "translate(" + px + "," + py + ") scale(" + iconScale +","+iconScale+") rotate(" + rot + ")");
          } else if (o.id != data.playerID) {
            updatePlayerShape(o.id); // add shape of vehicle if not found
          }
        }

        // player changed? update shapes?
        if(lastPlayerID != data.playerID) {
          if(lastPlayerID != -1) updatePlayerShape(lastPlayerID); // update shape of old vehicle
          updatePlayerShape(data.playerID); // update shape of new vehicle
          lastPlayerID = data.playerID;
        }

        // delete missing vehicles
        for(var key in vehicleShapes) {
          if(!data.objects[key]) {
            vehicleShapes[key].remove();
          }
        }
      });

      var prevMarkers = null
      var drawnMarkers = {}
      scope.$on('NavigationGroundMarkersUpdate', (evenet, data) => {
        //prevMarkers = null
        //if no previous markers, draw the whole route.
        if(!prevMarkers) {
          console.log("Making complete new path.")

          let markers = data.markers
          if(data) {
            for(var i=2; i<markers.length; i+=2) {
              var i1 = i+1
              var i2 = i+2
              var i3 = i+3
              if (i1 != undefined && i2 != undefined && i3 != undefined) {
                drawnMarkers[i+":"+i1+":"+i2+":"+i3] = _createLine( {
                  x:-markers[i],
                  y: markers[i1],
                  radius: 10
                }, {
                  x:-markers[i2],
                  y: markers[i3],
                  radius: 10
                }, data.color)
              }
            }
          }
        } else {
          let markers = data.markers
          for(var i=2; i<markers.length; i+=2) {
            var i1 = i+1
            var i2 = i+2
            var i3 = i+3
            if (drawnMarkers[i+":"+i1+":"+i2+":"+i3]) {
              drawnMarkers[i+":"+i1+":"+i2+":"+i3].remove()
              drawnMarkers[i+":"+i1+":"+i2+":"+i3] = undefined
            }
            if (markers[i1] != undefined && markers[i2] != undefined && markers[i3] != undefined) {
              drawnMarkers[i+":"+i1+":"+i2+":"+i3] = _createLine( {
                x:-markers[i],
                y: markers[i1],
                radius: 10
              }, {
                x:-markers[i2],
                y: markers[i3],
                radius: 10
              }, data.color)
            }
          }
        }
        if (data.markers.length === undefined) {
          for (var name in drawnMarkers) {
            if (!drawnMarkers[name]) {} else {
              drawnMarkers[name].remove()
            }
          }
        }
        prevMarkers = data.markers
        routeUpdate = true
      })

      function setupStaticMarkers(data) {
        if(data.key === undefined)
          return
        if(staticMarkersDict[data.key] === undefined) {
          staticMarkersDict[data.key] = {}
        }
        let dict = staticMarkersDict[data.key]

        // remove any existing collectable svgs
        for (var key in dict) {
          dict[key].marker.remove()
        }
        markerGroup = hu('<g>', auxsvg)
        // draw collectable svgs
        for(var i=0; i<data.items.length; i+=4) {
          /**
          let marker = hu('<image>', markerGroup)
          let icon = '/ui/modules/apps/navigation/missionIcons/'+data.items[i+3]+'.svg'
          marker.attr({
            x: -25, y:-25,
            width: 50, height: 50,
            style: style + "0px);",
            'xlink:href': icon
          })
          // store all collectable svgs
          **/

          let style = "transform: translate3d("+(-data.items[i+0])+"px,"+(data.items[i+1])+"px,"
          let marker = hu('<circle>', svg)
          marker.attr('cx', -data.items[i+0])
          marker.attr('cy', data.items[i+1])
          marker.attr('r', 8)
          marker.attr('fill', '#2C5CFF')
          marker.attr('style', style)
          marker.css('stroke', '#FFFFFF')
          marker.css('stroke-width', '3px')

          //marker.css('perspective-origin', '100% 100%' );
          //marker.css('perspective', '800px');
          //marker.css('transform', 'translateZ(' + 500 + 'px) scaleZ(' + 1 + ')');
          //marker.css('transform-style', 'preserve-3d');

          //marker.attr('visibility', 'hidden')


          dict[i/4.0] = {
            marker: marker,

            screenX: -data.items[i+0],
            screenY: data.items[i+1],
            visible: false
          }
        }
      }

      scope.$on('NavigationStaticMarkers', (event, data) => {
        if (data) setupStaticMarkers(data)
      })

      // receive the one-time map setup
      scope.$on('NavigationMapOld', function (event, data) {
        element.css({
          //'perspective': '500px',
          'background-color': 'rgba(50, 50, 50, 0.6)',
          'box-shadow': '0px 0px #fff',
          'overflow': 'hidden',
          'border-radius': '50%',
          'border': '3px solid rgba(20,20,20,0.8)',
          'transition': 'border-color 0.4s',
          'cursor': "pointer"
          //'transform': 'rotateX(60deg)',
        });

        angular.element(mapcontainer).css({
          //'transform': 'rotateX(60deg)',
        });

        function getDrivabilityColor(d) {
          if (d <= 0.1) return '#967864'; //'#967864'
          if (d > 0.1 && d < 0.9) return '#969678'; //'#969678'
          return '#DCDCDC'; //#DCDCDC'
        }

        // Draw the map elements
        var minX = -999, maxX = 999;
        var minY = -999, maxY = 999;
        var nodes = data.nodes

        // figure out dimensions of the road network
        for (var key in nodes) {
          var el = nodes[key]
          if (-el.pos[0] < minX) minX = -el.pos[0]
          if (-el.pos[0] > maxX) maxX = -el.pos[0]
          if (el.pos[1] < minY) minY = el.pos[1]
          if (el.pos[1] > maxY) maxY = el.pos[1]
        }

        if (data.minimapImage && data.terrainOffset && data.terrainSize) {
          // mapcontainer.style.backgroundSize = "100%"
          // mapcontainer.style.backgroundImage = "url('/" + data.minimapImage + "')"
          var bgImage = hu('<image>', svg).attr({
            'x': data.terrainOffset[0],
            'y': data.terrainOffset[1],
            'width': data.terrainSize[0],
            'height': data.terrainSize[1],
            'transform': "scale(-1,-1)",
            'xlink:href': "/" + data.minimapImage,
          }).prependTo(svg)
        } else {
          // draw grid
          var distX = maxX - minX
          var dx = 50
          for (var x = minX; x <= maxX + 1; x += dx) {
            _createLine({ x: x, y: minY, radius: 1 }, { x: x, y: maxY, radius: 1 }, '#FFFFFF55')
          }
          var distY = maxY - minY
          var dy = 50
          for (var y = minY; y <= maxY + 1; y += dy) {
            _createLine({ x: minX, y: y, radius: 1 }, { x: maxX, y: y, radius: 1 }, '#FFFFFF55')
          }

          /*
          // draw grid based on map terrain bounds
          var dx = 50
          for (var x = 0; x <= Math.round(data.terrainSize[1]) + 1; x += dx) {
            _createLine({ x: x, y: 0, radius: 1 }, { x: x, y: Math.round(-data.terrainSize[1]), radius: 1 }, '#FFFFFF55')
          }
          var dy = 50
          for (var y = 0; y >= Math.round(-data.terrainSize[1]) - 1; y -= dy) {
            _createLine({ x: 0, y: y, radius: 1 }, { x: Math.round(data.terrainSize[1]), y: y, radius: 1 }, '#FFFFFF55')
          }
          */

          /*
          //draw big grid
          var distX = maxX - minX
          minX = -999999, maxX = 999999;
          minY = -999999, maxY = 999999;
          var dx = 50
          for (var x = minX; x <= maxX + 1; x += dx) {
            _createLine({ x: x, y: minY, radius: 1 }, { x: x, y: maxY, radius: 1 }, '#FFFFFF55')
          }
          var distY = maxY - minY
          var dy = 50
          for (var y = minY; y <= maxY + 1; y += dy) {
            _createLine({ x: minX, y: y, radius: 1 }, { x: maxX, y: y, radius: 1 }, '#FFFFFF55')
          }
          */
        }

        function drawRoads(drivabilityMin, drivabilityMax) {
          for (var key in nodes) {
            var el = nodes[key];
            //1_createCircle(-el.pos[0], el.pos[1], el.radius, '#fa9e28'); // nodes
            if(-el.pos[0] < minX) minX = -el.pos[0];
            if(-el.pos[0] > maxX) maxX = -el.pos[0];
            if(el.pos[1] < minY) minY = el.pos[1];
            if(el.pos[1] > maxY) maxY = el.pos[1];

            if (el.links !== undefined) { // links
              for (var key2 in el.links) {
                var el2 = nodes[key2];
                var drivability = el.links[key2].drivability
                if (drivability >= drivabilityMin && drivability <= drivabilityMax) {
                  _createLine({x: -el.pos[0], y: el.pos[1], radius: el.radius*3}, {x: -el2.pos[0], y: el2.pos[1], radius: el2.radius*3}, getDrivabilityColor(drivability));
                }
              }
            }
          }
        }
        drawRoads(0, 0.1)
        drawRoads(0.1, 0.9)
        drawRoads(0.9, 1)

        mapReady = true;
        bngApi.activeObjectLua('extensions.load("uiNaviOld")');
      });

      bngApi.engineLua('extensions.load("ui_uiNaviOld")');
      bngApi.engineLua('registerCoreModule("ui/uiNaviOld")');
      bngApi.engineLua('extensions.ui_uiNaviOld.requestUIDashboardMap()');

      bngApi.engineLua(`extensions.core_collectables.sendUIState()`)
      bngApi.engineLua(`if gameplay_missions_missionEnter then gameplay_missions_missionEnter.sendMissionLocationsToMinimap() end`)
}}}]);